diff --git a/sys/libkern/strcspn.c b/sys/libkern/strcspn.c
new file mode 100644
index 0000000000..c90b4c513b
--- /dev/null
+++ b/sys/libkern/strcspn.c
@@ -0,0 +1,72 @@
+/*-
+ * Copyright (c) 2005 David Schultz <das@FreeBSD.ORG>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD: head/sys/libkern/strcspn.c 181748 2008-08-15 04:07:22Z kmacy $");
+
+#include <sys/libkern.h>
+#include <sys/types.h>
+#include <sys/limits.h>
+
+#define	IDX(c)	((u_char)(c) / LONG_BIT)
+#define	BIT(c)	((u_long)1 << ((u_char)(c) % LONG_BIT))
+
+size_t 
+strcspn(const char * __restrict s, const char * __restrict charset) 
+{
+	/*
+	 * NB: idx and bit are temporaries whose use causes gcc 3.4.2 to
+	 * generate better code.  Without them, gcc gets a little confused.
+	 */
+	const char *s1;
+	u_long bit;
+	u_long tbl[(UCHAR_MAX + 1) / LONG_BIT];
+	int idx;
+
+	if(*s == '\0')
+		return (0);
+
+#if LONG_BIT == 64	/* always better to unroll on 64-bit architectures */
+	tbl[0] = 1;
+	tbl[3] = tbl[2] = tbl[1] = 0;
+#else
+	for (tbl[0] = idx = 1; idx < sizeof(tbl) / sizeof(tbl[0]); idx++)
+		tbl[idx] = 0;
+#endif
+	for (; *charset != '\0'; charset++) {
+		idx = IDX(*charset);
+		bit = BIT(*charset);
+		tbl[idx] |= bit;
+	}
+
+	for(s1 = s; ; s1++) {
+		idx = IDX(*s1);
+		bit = BIT(*s1);
+		if ((tbl[idx] & bit) != 0)
+			break;
+	}
+	return (s1 - s);
+}
diff --git a/sys/sys/libkern.h b/sys/sys/libkern.h
index b06300bf28..e5a2a03be3 100644
--- a/sys/sys/libkern.h
+++ b/sys/sys/libkern.h
@@ -122,6 +122,7 @@ int	 skpc(int, int, char *);
 void	 skrandom(u_long);
 char	*strcat(char * __restrict, const char * __restrict);
 char	*strncat(char * __restrict, const char * __restrict, size_t);
+<<<<<<< HEAD
 int	 strcmp(const char *, const char *);
 int	 strcasecmp(const char *, const char *);
 char	*strcpy(char * __restrict, const char * __restrict);
@@ -131,6 +132,18 @@ size_t	 strlen(const char *);
 int	 strncmp(const char *, const char *, size_t);
 int	 strncasecmp(const char *, const char *, size_t);
 char	*strncpy(char * __restrict, const char * __restrict, size_t);
+=======
+int	 strcmp (const char *, const char *);
+int	 strcasecmp (const char *, const char *);
+char	*strcpy (char * __restrict, const char * __restrict);
+size_t	 strcspn(const char * __restrict, const char * __restrict) __pure;
+size_t   strlcat (char *, const char *, size_t);
+size_t   strlcpy (char *, const char *, size_t);
+size_t	 strlen (const char *);
+int	 strncmp (const char *, const char *, size_t);
+int	 strncasecmp (const char *, const char *, size_t);
+char	*strncpy (char * __restrict, const char * __restrict, size_t);
+>>>>>>> kernel/drm: nouveau changes so far. :)
 size_t	 strnlen(const char *, size_t);
 char	*strsep(char **, const char *);
 char	*strstr(const char *, const char *);
-- 
2.23.0

